#include <c:\keil\c51\inc\stdio.h>				/* standard I/O .h-file               */
#include <c:\keil\c51\inc\ctype.h>				/* character functions                */
#include <c:\keil\c51\inc\string.h>				/* string and memory functions        */
#include <c:\keil\c51\inc\stdlib.h>
#include <reg51.h>
#include <dsw.h>

#define	Port P1
#define Riadok1 0x80
#define Riadok2 (Riadok1|0x40)

#include <adresy.inc>

sbit E    = P3^7;
sbit RS   = P3^5;

extern void Reset(void);
extern char Logo(void);
extern char Readkey(void);
extern char Delay(unsigned char);

unsigned char Hod,Min,Sec;

char Buffer[16+1];

typedef enum {ON=0,OFF=1} State_Port;

void Delay2(unsigned int Time)
{
 while(--Time!=0x0000);
}

void Put_Ins(unsigned char Instrukcia)
{
 Port=Instrukcia&0xF0;
 RS=0;
 E=1; 
 Delay2(0x50);					//Pockam cca. 2000us	
 E=0;
 Delay2(0x50);					//Pockam cca. 2000us	 
 
 Port=(Instrukcia<<4)&0xF0;
 RS=0;
 E=1; 
 Delay2(0x50);					//Pockam cca. 2000us	
 E=0;
 Delay2(0x50);					//Pockam cca. 2000us	 
}

void Init_Display(void)
{

 RS=E=0;
 Port=0x10;
 E=1;
 E=0;
 Delay2(0x50);					
 E=1;
 E=0;
 Delay2(0x50);					
 E=1;
 E=0;
 Port=0x02;
 E=1;
 E=0; 
 Put_Ins(0x28);
 Put_Ins(0x0E);
 Put_Ins(0x01);
 Put_Ins(0x06);
 Put_Ins(0x80);
}

void ClrScr(void)
{
 E=RS=0;
 Put_Ins(0x01); 
}

void Put_String(unsigned char Instrukcia)
{
 unsigned char i,Temp;
 Put_Ins(Instrukcia);
 for(i=0x00; i<=(sizeof(Buffer)); i++)
  {
	 switch(Temp=Buffer[i])			//Je to tu kvoli poslednemu znaku \r \n ktory sa zbytocne zobrazoval
	  {
		 case	'\0'	:
		 case	'\n'	:
		 case	'\r'	:		Temp=' '; break;
		}
   Port=Temp&0xF0;
   Buffer[i]=' ';
   RS=E=1;
	 Delay(0x80);
   E=0;
	 Port=(Temp<<4)&0xF0;
   RS=E=1;
	 Delay(0x80);
   E=0;
  }
}

void Init_Serial(void)
{
 #define XTAL 18.432E6
 #define BAUD 19200
 TH1=TL1=(0x100-(((long int)XTAL/192)/BAUD));
 PCON|=0x80;				//Dvojita prenosova rychlost
 SCON|=0x50;				//8 bit prenos
 TMOD|=0x20;				//8 bitovy autoreload
 TR1=1;							//Running timer
// TI=1;							//Musi byt, pretoze sa to vyzaduje od Keila pre printf() !!!
}

void Citaj_String(void)
{
 unsigned char i=0x00; bit Flag=0;
 while(Flag==0)
  {
	 switch(Buffer[i++]=Readkey())
	  {
		 case	'\n'	:
		 case	'\r'	:
		 case	'\0'	:	Flag=1; break;					//Citam RS232 az pokial nenarazim na koniec riadku, fungujem ako gets() ........
		}
  }
}

void main(void)
{
 Init_Display();
 ClrScr();
 Init_Serial();
 strcpy(Buffer,"DSW Soft (c)2012");
 Put_String(Riadok1);
 strcpy(Buffer,"Eduard Jadron");
 Put_String(Riadok2);
 Delay2(0xFFFF);
 while(1)
  {
   switch (Readkey())			//Cakam na token ...
    {
		 case	Token	:	switch(Readkey())					//Cakam na adresu ...
								 {
									case	Adresa1	: Citaj_String(); Put_String(Riadok1); break;
									case	Adresa2	: Citaj_String(); Put_String(Riadok2); break;
									case	Token		:	
									case	Adresa0	: 
									case	AdresaX	:	strcpy(Buffer," *** RESET *** "); Put_String(Riadok1);
																	strcpy(Buffer,"ATMEL AT89C2051"); Put_String(Riadok2);
																	Delay2(0xFFFF); Delay2(0xFFFF); Delay2(0xFFFF); Delay2(0xFFFF);
																	Reset(); 		//Poslem reset na AT89C2051 ...
																	break;
								}
								break;
		}
  }
}