#include <at89LP4052.h>
#include <stdio.h>				/* standard I/O .h-file               */
#include <ctype.h>				/* character functions                */
#include <string.h>				/* string and memory functions        */
#include <stdlib.h>
#include <rtx51tny.h>
#include <dsw.h>

#define AddrDS1631A	0x90

#define STUPEN 0xDF

enum {ON=0,OFF=1};

sbit	Relay			=	P1^3;

sbit	Plu	= P3^5;
sbit	Min	= P1^2;
sbit	Ent	=	P3^4;

#define	SYSTEM		0
#define	CLOCK			1
#define	POLEJ   2

//ol(! * ?PR?_WRITE_EPROM_DS1624?DS1631)

extern char Get_Int_Temp(unsigned char);
extern unsigned char Riadok1,Riadok2;

extern void LCD_Init(void);
extern void LCD_Home(void);
extern void LCD_Goto(unsigned char);
extern void LCD_Write_String(char*);

extern void Write_Eprom_DS1624(unsigned char, unsigned char);
extern unsigned char Read_Eprom_DS1624(unsigned char,unsigned char);

extern unsigned char Buffer[LCD_Size+1];
 
struct Hodiny
{
 unsigned char Hod,Min,Sek,Des,Tz,Ts;
};

struct Hodiny Cas = {6,15,0,0,20};

void Clock(void) _task_ CLOCK
{
 while(1)
  {
	 os_wait(K_IVL,100,NULL);
	 os_send_signal(SYSTEM);
	 if(++Cas.Des==10)
	  {
		 Cas.Des=0;
		 if(++Cas.Sek==60)
		  {
			 Cas.Sek=0;
			 if(++Cas.Min==60)
			  {
				 Cas.Min=0;
				 if(++Cas.Hod==24)
				  {
					 Cas.Hod=0;
					}
				}
			}
		}
	}	
}

void Polej(void) _task_ POLEJ
{
 while(1)
 {
  switch(os_wait(K_TMO,250,NULL))
   {
    case TMO_EVENT : Cas.Ts=Get_Int_Temp(AddrDS1631A); break;
    case SIG_EVENT : if(Cas.Tz>Cas.Ts)Relay=ON; else Relay=OFF; break;
   }
 }
}

void System(void) _task_ SYSTEM
{
 #ifdef DATE
   code unsigned char *SystemTime[]={__TIME__,__DATE__,__DATE2__,__C51__};
   sscanf(SystemTime[0],"%02bd:%02bd:%02bd",&Cas.Hod,&Cas.Min,&Cas.Sek);
 #endif
 LCD_Init();
 os_create_task(CLOCK);
 os_create_task(POLEJ); 
 while(1)
  {
	 switch(os_wait(K_TMO+K_SIG,0xFF,NULL))
	  {
		 case	TMO_EVENT	:	break;
		 case	SIG_EVENT	:
           if((Plu==ON)&&(Ent==ON)) {while(Plu==ON) os_wait(K_TMO,100,NULL); if(++Cas.Min==60) Cas.Min=0;}
											if((Min==ON)&&(Ent==ON)) {while(Min==ON) os_wait(K_TMO,100,NULL); if(++Cas.Hod==24) Cas.Hod=0;}
           if((Plu==ON)&&(Ent==OFF)) {os_wait(K_TMO,250,NULL); Cas.Tz++;}
           if((Min==ON)&&(Ent==OFF)) {os_wait(K_TMO,250,NULL); Cas.Tz--;}
											LCD_Goto(Riadok1);
											sprintf(Buffer,"Poliat %c,Tz=%2bdC",(Cas.Tz>Cas.Ts)?'!':' ',Cas.Tz);
											LCD_Write_String(Buffer);
											LCD_Goto(Riadok2);
											sprintf(Buffer,"%02bd%c%02bd:%02bd,Ts=%2bdC",Cas.Hod,(Cas.Des>4)?' ':':',Cas.Min,Cas.Sek,Cas.Ts);
           if((Cas.Hod>=21)&(Cas.Hod<=7)) os_send_signal(POLEJ);
											LCD_Write_String(Buffer);
											break;
		}
	}
}